/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.hive.ql.plan;

import java.io.Serializable;

import org.apache.hadoop.hive.ql.plan.Explain.Level;

@Explain(displayName="Drop WM Trigger",
    explainLevels={ Level.USER, Level.DEFAULT, Level.EXTENDED })
public class DropWMTriggerDesc extends DDLDesc implements Serializable {
  private static final long serialVersionUID = 963803766313787632L;

  private String rpName;
  private String triggerName;

  public DropWMTriggerDesc() {}

  public DropWMTriggerDesc(String rpName, String triggerName) {
    this.rpName = rpName;
    this.triggerName = triggerName;
  }

  @Explain(displayName="resourcePlanName",
      explainLevels={ Level.USER, Level.DEFAULT, Level.EXTENDED })
  public String getRpName() {
    return rpName;
  }

  public void setRpName(String rpName) {
    this.rpName = rpName;
  }

  @Explain(displayName="triggerName",
      explainLevels={ Level.USER, Level.DEFAULT, Level.EXTENDED })
  public String getTriggerName() {
    return triggerName;
  }

  public void setTriggerName(String triggerName) {
    this.triggerName = triggerName;
  }
}
